# Contributing to MatX

If you are interested in contributing to MatX, your contributions will fall
into three categories:
1. You want to report a bug, feature request, or documentation issue
    - File an [issue](https://github.com/NVIDIA/MatX/issues/new)
    describing what you encountered or what you want to see changed.
    - The MatX team will evaluate the issues and triage them, scheduling
    them for a release. If you believe the issue needs priority attention
    comment on the issue to notify the team.
2. You want to propose a new Feature and implement it
    - Post about your intended feature, and we shall discuss the design and
    implementation.
    - Once we agree that the plan looks good, go ahead and implement it, using
    the [code contributions](#code-contributions) guide below.
3. You want to implement a feature or bug-fix for an outstanding issue
    - Follow the [code contributions](#code-contributions) guide below.
    - If you need more context on a particular issue, please ask and we shall
    provide.

## Code contributions

### Your first issue

1. Read the project's [README.md](https://github.com/nvidia/matx/blob/main/README.md) to learn how to setup the development environment
2. Find an issue to work on. The best way is to look for the [good first issue](https://github.com/NVIDIA/MatX/labels/good%20first%20issue) or [help wanted](https://github.com/NVIDIA/MatX/labels/help%20wanted) labels
3. Comment on the issue saying you are going to work on it
4. Code! Make sure to update unit tests!
5. When done, [create your pull request](https://github.com/nvidia/matx/compare)
6. Wait for other developers to review your code and update code as needed
7. Once reviewed and approved, a MatX developer will merge your pull request

Remember, if you are unsure about anything, don't hesitate to comment on issues
and ask for clarifications!

### Seasoned developers

Once you have gotten your feet wet and are more comfortable with the code, you
can look at the prioritized issues of our next release in our [project boards](https://github.com/nvidia/matx/projects).


## Attribution
Portions adopted from https://github.com/pytorch/pytorch/blob/master/CONTRIBUTING.md
